﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;
using AMWD.Modbus.Common.Structures;
using AMWD.Modbus.Tcp.Client;
using Newtonsoft.Json;
using System.Configuration;

namespace winform_OperatorAPITest_07012021
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            //set button color as TM style
            ColorSetAtBeginning();
            //initialize selection box for palletizing/depalletizing/change pallet
            comboBox1.Items.AddRange(ApplicationSelection);
            tabControl1.SelectTab(1);
            //hide tab header
            tabControl1.ItemSize = new Size(0, 1);
            tabControl1.SizeMode = TabSizeMode.Fixed;
            //hide api status display for normal mode(show while engineer mode)
            statusStrip2.Visible = false;
            //set api ip and port for the first time
            client.BaseAddress = new Uri("https://127.0.0.1:9845");
            client_token.BaseAddress = new Uri("https://127.0.0.1:9833");
            timer1.Enabled = false;
            OpenFlowAndOperatorAPI();
        }
        //===============================================
        //Var get from app.config
        public string RobotIP=ConfigurationManager.AppSettings["RobotIP"];
        public string ShareFolder = ConfigurationManager.AppSettings["ShareFolder"];
        public string FlowProjectName = ConfigurationManager.AppSettings["FlowProjectName"];
        public string OperatorAPIFolderPath = ConfigurationManager.AppSettings["OperatorAPIFolderPath"];

        //Var initialize
        public string[] ApplicationSelection = new string[] { "Palletizing", "Depalletizing", "Change_Pallet" };
        static string CurrentExecutingXmlFile { get; set; }
        static List<string> OldXmlFile_ForDisplay = new List<string>();
        static List<string> OldXmlFile_FullName = new List<string>();
        public HttpClient client = new HttpClient();
        public HttpClient client_token = new HttpClient();
        static APIResponse apifeedback = new APIResponse();
        static string CurrentCoordinate { get; set; }
        static ModbusClient modbusclient { get; set; }
        static int TabNumberBeforeJump { get; set; }
        //===============================================
        //class declare
        public class Bodymessage
        {
            public string OperatorApiFunctionName { get; set; }
            public string Parameter { get; set; }
        }
        public class APIResponse
        {
            public string success { get; set; }
            public string ErrorCode{ get; set; }
            public string responseData { get; set; }
        }
        public class User
        {
            public string userName { get; set; }
            public string password { get; set; }
            public string token { get; set; }
        }
        //===============================================
        public void ColorSetAtBeginning()
        {
            button27.FlatStyle = FlatStyle.Flat;
            button27.FlatAppearance.MouseDownBackColor= ColorTranslator.FromHtml("#006A8E");
            button27.BackColor= ColorTranslator.FromHtml("#78BE21");
            button3.FlatStyle = FlatStyle.Flat;
            button3.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button3.BackColor = ColorTranslator.FromHtml("#78BE21");
            button2.FlatStyle = FlatStyle.Flat;
            button2.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button2.BackColor = ColorTranslator.FromHtml("#78BE21");
            button7.FlatStyle = FlatStyle.Flat;
            button7.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button7.BackColor = ColorTranslator.FromHtml("#78BE21");
            button5.FlatStyle = FlatStyle.Flat;
            button5.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button5.BackColor = ColorTranslator.FromHtml("#78BE21");
            button49.FlatStyle = FlatStyle.Flat;
            button49.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button49.BackColor = ColorTranslator.FromHtml("#78BE21");
            button4.FlatStyle = FlatStyle.Flat;
            button4.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button4.BackColor = ColorTranslator.FromHtml("#78BE21");
            button9.FlatStyle = FlatStyle.Flat;
            button9.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button9.BackColor = ColorTranslator.FromHtml("#78BE21");
            button11.FlatStyle = FlatStyle.Flat;
            button11.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button11.BackColor = ColorTranslator.FromHtml("#78BE21");
            button8.FlatStyle = FlatStyle.Flat;
            button8.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button8.BackColor = ColorTranslator.FromHtml("#78BE21");
            button24.FlatStyle = FlatStyle.Flat;
            button24.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button24.BackColor = ColorTranslator.FromHtml("#78BE21");
            button53.FlatStyle = FlatStyle.Flat;
            button53.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button53.BackColor = ColorTranslator.FromHtml("#78BE21");
            button59.FlatStyle = FlatStyle.Flat;
            button59.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button59.BackColor = ColorTranslator.FromHtml("#78BE21");
            button12.FlatStyle = FlatStyle.Flat;
            button12.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button12.BackColor = ColorTranslator.FromHtml("#78BE21");
            button28.FlatStyle = FlatStyle.Flat;
            button28.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button28.BackColor = ColorTranslator.FromHtml("#78BE21");
            button29.FlatStyle = FlatStyle.Flat;
            button29.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button29.BackColor = ColorTranslator.FromHtml("#78BE21");
            button20.FlatStyle = FlatStyle.Flat;
            button20.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button20.BackColor = ColorTranslator.FromHtml("#78BE21");
            button22.FlatStyle = FlatStyle.Flat;
            button22.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button22.BackColor = ColorTranslator.FromHtml("#78BE21");
            button52.FlatStyle = FlatStyle.Flat;
            button52.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button52.BackColor = ColorTranslator.FromHtml("#78BE21");
            button58.FlatStyle = FlatStyle.Flat;
            button58.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button58.BackColor = ColorTranslator.FromHtml("#78BE21");
            button39.FlatStyle = FlatStyle.Flat;
            button39.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button39.BackColor = ColorTranslator.FromHtml("#78BE21");
            button40.FlatStyle = FlatStyle.Flat;
            button40.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button40.BackColor = ColorTranslator.FromHtml("#78BE21");
            button41.FlatStyle = FlatStyle.Flat;
            button41.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button41.BackColor = ColorTranslator.FromHtml("#78BE21");
            button42.FlatStyle = FlatStyle.Flat;
            button42.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button42.BackColor = ColorTranslator.FromHtml("#78BE21");
            button43.FlatStyle = FlatStyle.Flat;
            button43.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button43.BackColor = ColorTranslator.FromHtml("#78BE21");
            button51.FlatStyle = FlatStyle.Flat;
            button51.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button51.BackColor = ColorTranslator.FromHtml("#78BE21");
            button50.FlatStyle = FlatStyle.Flat;
            button50.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button50.BackColor = ColorTranslator.FromHtml("#78BE21");
            button54.FlatStyle = FlatStyle.Flat;
            button54.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button54.BackColor = ColorTranslator.FromHtml("#78BE21");
            button26.FlatStyle = FlatStyle.Flat;
            button26.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button26.BackColor = ColorTranslator.FromHtml("#78BE21");
            button32.FlatStyle = FlatStyle.Flat;
            button32.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button32.BackColor = ColorTranslator.FromHtml("#78BE21");
            button33.FlatStyle = FlatStyle.Flat;
            button33.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button33.BackColor = ColorTranslator.FromHtml("#78BE21");
            button34.FlatStyle = FlatStyle.Flat;
            button34.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button34.BackColor = ColorTranslator.FromHtml("#78BE21");
            button35.FlatStyle = FlatStyle.Flat;
            button35.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button35.BackColor = ColorTranslator.FromHtml("#78BE21");
            button36.FlatStyle = FlatStyle.Flat;
            button36.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button36.BackColor = ColorTranslator.FromHtml("#78BE21");
            button37.FlatStyle = FlatStyle.Flat;
            button37.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button37.BackColor = ColorTranslator.FromHtml("#78BE21");
            button55.FlatStyle = FlatStyle.Flat;
            button55.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button55.BackColor = ColorTranslator.FromHtml("#78BE21");
            button38.FlatStyle = FlatStyle.Flat;
            button38.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button38.BackColor = ColorTranslator.FromHtml("#78BE21");
            button45.FlatStyle = FlatStyle.Flat;
            button45.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button45.BackColor = ColorTranslator.FromHtml("#78BE21");
            button46.FlatStyle = FlatStyle.Flat;
            button46.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button46.BackColor = ColorTranslator.FromHtml("#78BE21");
            button47.FlatStyle = FlatStyle.Flat;
            button47.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button47.BackColor = ColorTranslator.FromHtml("#78BE21");
            button56.FlatStyle = FlatStyle.Flat;
            button56.FlatAppearance.MouseDownBackColor = ColorTranslator.FromHtml("#006A8E");
            button56.BackColor = ColorTranslator.FromHtml("#78BE21");
        }
        //function: get token from robot API first
        public async Task OperatorAPIToken(string username, string password)
        {
            User user = new User() { userName = username, password = password };
            Task<HttpResponseMessage> response = client_token.PostAsync("/HttpServer/GetToken", new StringContent(JsonConvert.SerializeObject(user), Encoding.UTF8, "application/json"));
            HttpResponseMessage responseBody = await response;
            string userserialize = await responseBody.Content.ReadAsStringAsync();
            User passuser = JsonConvert.DeserializeObject<User>(userserialize);
            if (passuser.token=="")
            {
                label31.Text = "API Token not get";
                label31.ForeColor=Color.White;
                label31.BackColor = Color.Red;
            }
            else
            {
                label31.Text = "API Token get";
                label31.ForeColor = Color.White;
                label31.BackColor = Color.Green;
                client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", passuser.token);
            }
        }
        //function: API functions
        public async Task OperatorAPI(string FunctionName, string parameter)
        {
            var bodymessage = new Bodymessage
            {
                OperatorApiFunctionName = FunctionName,
                Parameter = parameter
            };
            var stringcontent= new StringContent(JsonConvert.SerializeObject(bodymessage), Encoding.UTF8, "application/json");
            Task<HttpResponseMessage> response = client.PostAsync("/HttpServerOperatorApi/OperatorAction", stringcontent);
            HttpResponseMessage responseBody = await response;
            string apiresponse = await responseBody.Content.ReadAsStringAsync();
            apifeedback = JsonConvert.DeserializeObject<APIResponse>(apiresponse);
            toolStripStatusLabel2.Text = "Time now: "+DateTime.Now.ToString("MM/dd  HH:mm:ss");
            toolStripStatusLabel3.Text= "; API Function: "+FunctionName;
            toolStripStatusLabel4.Text= "; parameter: " + parameter;
            toolStripStatusLabel5.Text = "; success: " + apifeedback.success;
            toolStripStatusLabel6.Text= "; ErrorCode: " + apifeedback.ErrorCode;
            toolStripStatusLabel7.Text= "; responseData: "+apifeedback.responseData;
        }

        // function: Open Flow or Studio
        public void ExecuteAsAdmin(string fileName, string arguments, string workingdirectory, ProcessWindowStyle windowstyle)
        {
            ProcessStartInfo proc = new ProcessStartInfo();
            proc.FileName = fileName;
            proc.UseShellExecute = true;
            proc.Arguments = arguments;
            proc.WorkingDirectory = workingdirectory;
            proc.WindowStyle = windowstyle;
            proc.Verb = "runas";
            Process.Start(proc);
        }

        //function: save new XML file
        public void SaveNewXmlFile()
        {
            XmlDocument xDoc = new XmlDocument();
            xDoc.Load("C:\\Techman Robot\\TMstudio\\pallet\\TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + ".xml");
            string newValue = "TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + "_" + textBox1.Text.ToString();
            xDoc.DocumentElement.SelectSingleNode("FILE_NAME").InnerText = newValue;
            xDoc.Save("C:\\Techman Robot\\TMstudio\\pallet\\TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + "_" + textBox1.Text.ToString() + ".xml");
            CurrentExecutingXmlFile = "TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + "_" + textBox1.Text.ToString() + ".xml";
        }

        //function: HideAllSubflowAndThread in TM flow
        private async Task HideAllSubflowAndThread()
        {
            await OperatorAPI("GetFlowList", "");
            var flowlist = JsonConvert.DeserializeObject<List<List<object>>>(apifeedback.responseData)
            .Select(arr => arr.OfType<string>().ToList())
            .ToList();
            List<string> Mainflow_List = flowlist[0];
            List<string> Subflow_List = flowlist[1];
            List<string> Thread_List = flowlist[2];
            List<string> NonPauseThread_List = flowlist[3];

            string Mainflow_doublequote = "\"" + string.Join("\", \"", Mainflow_List) + "\"";
            string Subflow_doublequote = "\"" + string.Join("\", \"", Subflow_List) + "\"";
            string Thread_doublequote = "\"" + string.Join("\", \"", Thread_List) + "\"";
            string NonPauseThread_doublequote = "\"" + string.Join("\", \"", NonPauseThread_List) + "\"";

            await OperatorAPI("HideSubflows", "[" + Subflow_doublequote + "]");
            await OperatorAPI("HideThreads", "[" + Thread_doublequote + "]");
            await OperatorAPI("HideThreads", "[" + NonPauseThread_doublequote + "]");
        }

        //function: read all xml file name except original template xml 
        private void XmlFileNameInPalletFolder()
        {
            OldXmlFile_ForDisplay.Clear();
            OldXmlFile_FullName.Clear();
            string[] nnnn = Directory.GetFiles(@"C:\Techman Robot\TMstudio\pallet", "*.xml");
            foreach (string aaa in nnnn)
            {
                string ccc=aaa.Remove(0, 33);
                OldXmlFile_FullName.Add(ccc);

                string bbb = aaa.Remove(0, 55);
                if (bbb.Length > 6)
                {
                    bbb = bbb.Remove(bbb.Length - 4);
                }
                OldXmlFile_ForDisplay.Add(bbb);
            }
            OldXmlFile_ForDisplay.RemoveAll(x => x == "0.xml");
            OldXmlFile_ForDisplay.RemoveAll(x => x == "1.xml");
            OldXmlFile_ForDisplay.RemoveAll(x => x == "2.xml");
            OldXmlFile_FullName.RemoveAll(x => x == "TMPalletizingOperator_0.xml");
            OldXmlFile_FullName.RemoveAll(x => x == "TMPalletizingOperator_1.xml");
            OldXmlFile_FullName.RemoveAll(x => x == "TMPalletizingOperator_2.xml");
        }
        
        //function: delete old layout.txt file on PC
        private void DeleteLayoutTxtFileOnPC()
        {
            if (File.Exists(@"C:\\Techman Robot\\TMstudio\\TM_Export\\TMstudio\\TextFiles\\Layout.txt"))
            {
                File.Delete(@"C:\\Techman Robot\\TMstudio\\TM_Export\\TMstudio\\TextFiles\\Layout.txt");
            }
        }
        //function: status bar text and color change
        public void StatusBarShow(string TetxToShow, Color BackColor)
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToString("MM/dd  HH:mm:ss") + " : "+TetxToShow;
            statusStrip1.BackColor=BackColor;
            toolStripStatusLabel1.ForeColor = Color.White;
        }
        //function: Connect+Login+GetControl+ModbusConnectCheck
        private async void Connect_Login_Getcontrol_ModbusConnectCheck()
        {
            await OperatorAPI("ConnectRobot", RobotIP);
            await OperatorAPI("LogIn", "[\"administrator\",\"\"]");
            await OperatorAPI("GetControl", "true");
            if (apifeedback.success.ToString() == "true")
            {
                label26.Text = "Robot GetControl";
                label26.ForeColor = Color.White;
                label26.BackColor = Color.Green;

                modbusclient.ReconnectTimeSpan = TimeSpan.FromSeconds(1);
                await modbusclient.Connect();
                if (modbusclient.IsConnected == true)
                {
                    label27.Text = "Modbus connect";
                    label27.ForeColor = Color.White;
                    label27.BackColor = Color.Green;
                }
                else
                {
                    label27.Text = "Modbus Not connect";
                    label27.ForeColor = Color.White;
                    label27.BackColor = Color.Red;
                }
            }
            else
                    {
                        label26.Text = "Robot Not GetControl";
                        label26.ForeColor = Color.White;
                        label26.BackColor = Color.Red;
                    }
        }
        private async void OpenFlowAndOperatorAPI()
        {
            ExecuteAsAdmin("C:\\Techman Robot\\TM flow\\TMflow.exe", "-S", "", ProcessWindowStyle.Minimized);
            await Task.Delay(2000);
            ExecuteAsAdmin(OperatorAPIFolderPath+ "_start.bat", "", OperatorAPIFolderPath, ProcessWindowStyle.Minimized);
        }

        //==================================================================================
        //TAB CONTAINER
        //==================================================================================
        //tab1 Engineer mode testing buttons
        //1.1 Open Flow
        private async void button63_Click(object sender, EventArgs e)
        {
            await OperatorAPIToken("admin", "tm1234");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ExecuteAsAdmin("C:\\Techman Robot\\TM flow\\TMflow.exe", "-S", "", ProcessWindowStyle.Minimized);
        }

        private async void button18_Click(object sender, EventArgs e)
        {
           await OperatorAPI("LeaveTMflow", "true");
        }

        //1.2 API: HideTMflow, ConnectRobot, Login, Getcontrol, OpenProject
        private async void button6_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowTMflow", "true" );
        }

        private async void button13_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowTMflow", "false" );
        }

        private async void button14_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ConnectRobot", textBox4.Text);
        }

        private async void button15_Click(object sender, EventArgs e)
        {
            await OperatorAPI("LogIn", "[\"administrator\",\"\"]");
        }

        private async void button10_Click(object sender, EventArgs e)
        {
            await OperatorAPI("LogOut", "");
        }


        private async void button16_Click(object sender, EventArgs e)
        {
            await OperatorAPI("GetControl", "true");
        }

        private async void button17_Click(object sender, EventArgs e)
        {
            await OperatorAPI("OpenProject", "[\""+textBox10.Text +"\"]");
        }

        private async void button19_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
        }

        private async void button21_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowPage", "SettingTextFileManager");
        }

        private async void button23_Click(object sender, EventArgs e)
        {
            await OperatorAPI("GetProjectList", "");
            string[] projectneeded = { "TMOperator_TMROBOT_TMPLTZOP_V002_Main", "TMOperator_TMROBOT_TMPLTZOP_V002_Grip", "TMOperator_TMROBOT_TMPLTZOP_V002_Pillar", "TMOperator_TMROBOT_TMPLTZOP_V002_Release" };
            checkBox1.Checked = projectneeded.All(apifeedback.responseData.Contains);
        }

        private async void button25_Click(object sender, EventArgs e)
        {
            await OperatorAPI("GetPointList", "");
        }

        private async void button31_Click(object sender, EventArgs e)
        {
            await OperatorAPI("IsRobotLink", "");
        }

        private async void button30_Click(object sender, EventArgs e)
        {
            await HideAllSubflowAndThread();
        }
        private async void button48_Click(object sender, EventArgs e)
        {
            await OperatorAPI("GetNetworkServiceList", "");
        }
        private void button44_Click(object sender, EventArgs e)
        {
            Connect_Login_Getcontrol_ModbusConnectCheck();
        }
        //===============================================
        //tab2 
        //tab2.1 Go to StartNewProject page
        private async void button27_Click(object sender, EventArgs e)
        {
            modbusclient = new ModbusClient(RobotIP, 502);
            await OperatorAPIToken("admin", "tm1234");
            Connect_Login_Getcontrol_ModbusConnectCheck();
            tabControl1.SelectTab(2);
            StatusBarShow("Let's start work on new project...", Color.Green);
        }
        //tab2.2 Check excist xml names, Go to EditOldProject page
        private async void button3_Click(object sender, EventArgs e)
        {
            modbusclient = new ModbusClient(RobotIP, 502);
            await OperatorAPIToken("admin", "tm1234");
            Connect_Login_Getcontrol_ModbusConnectCheck();
            comboBox2.DataSource = null;
            XmlFileNameInPalletFolder();
            comboBox2.DataSource = OldXmlFile_ForDisplay;
            comboBox2.SelectedItem = null;
            tabControl1.SelectTab(3);
            StatusBarShow("Let's work on previous project...", Color.Green);
        }
        //===============================================
        //tab3
        //tab3.1 start new project, save new xml, and Open Studio with the new project xml file created
        private void button2_Click(object sender, EventArgs e)
        {
            if(comboBox1.SelectedIndex==-1)
            {
                StatusBarShow("please select application from drop down list.", Color.Red);
            }
            else
            {
                XmlFileNameInPalletFolder();
                if(OldXmlFile_FullName.Contains("TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + "_" + textBox1.Text.ToString() + ".xml") ==true)
                {
                    StatusBarShow("Project already exist, please use another name.", Color.Red);
                }
                else
                {
                    SaveNewXmlFile();
                    if (File.Exists("C:\\Techman Robot\\TMstudio\\pallet\\"+ CurrentExecutingXmlFile) ==true)
                    {
                        StatusBarShow("New Project Create Complete! Let's edit it.", Color.Green);
                        ExecuteAsAdmin("C:\\Techman Robot\\TMstudio\\TMstudio.exe", "-S -Page \"Palletizing Wizard\" -File \"TMPalletizingOperator_" + comboBox1.SelectedIndex.ToString() + "_" + textBox1.Text.ToString() + ".xml\" ", "C:\\Techman Robot\\TMstudio\\", ProcessWindowStyle.Maximized);
                    }
                    else
                    {
                        StatusBarShow("Project failed to save, please check.", Color.Red);
                    }
                }
            }
            
        }
        //tab3.1.2 Open keypad when click on textbox
        private void textBox1_Click(object sender, EventArgs e)
        {
            ExecuteAsAdmin("C:\\Techman Robot\\TM flow\\Tools\\keyboard\\TMKeyboard.exe", "", "", ProcessWindowStyle.Normal);
        }
        //tab3.2 Check if the Layout.txt is export to PC correctly, delete Layout.txt in robot, import layout.txt from PC to robot, open FlowProject:MAIN
        private async void button7_Click(object sender, EventArgs e)
        {
            if (File.Exists(@"C:\\Techman Robot\\TMstudio\\TM_Export\\TMstudio\\TextFiles\\Layout.txt"))
            {
                await OperatorAPI("DeleteTextFile", "[\"Layout.txt\"]");
                await OperatorAPI("ImportTextFileFromExternalDevice", "[\""+ShareFolder+"\",\"TMstudio\",\"Layout.txt\"]");
                if (apifeedback.success.ToString()=="true")
                { 
                    //await OperatorAPI("OpenProject", "[\"TMOperator_TMROBOT_TMPLTZOP_V002_Main\"]");
                    await OperatorAPI("OpenProject", "[\""+FlowProjectName+"\"]");
                    if (apifeedback.ErrorCode == null)
                    {
                        StatusBarShow("Latest layout.txt is imported, Flow project opened.", Color.Green);
                        tabControl1.SelectTab(4);
                    }
                    else
                    {
                        StatusBarShow("Flow Project open failed, please check!", Color.Red);
                    }
                }
                else
                {
                    StatusBarShow("layout.txt import failed, please check for network connection!", Color.Red);
                }
            }
            else
            {
                StatusBarShow("Can not find Layout.txt on PC, TMstudio export is not done properly.", Color.Red);
            }
        }
        //===============================================
        //tab4
        //tab4.1 Open Studio with the old project xml file selected from combobox
        private void button5_Click(object sender, EventArgs e)
        {
            string SelectedXml = OldXmlFile_FullName[comboBox2.SelectedIndex];
            CurrentExecutingXmlFile = SelectedXml;
            ExecuteAsAdmin("C:\\Techman Robot\\TMstudio\\TMstudio.exe", "-S -Page \"Palletizing Wizard\" -File \""+SelectedXml+"\" ", "C:\\Techman Robot\\TMstudio\\", ProcessWindowStyle.Maximized);
            DeleteLayoutTxtFileOnPC();
            StatusBarShow("Previous project selected! Let's edit it.", Color.Green);
        }
        //tab4.1 delete selected project
        private void button49_Click(object sender, EventArgs e)
        {
            string SelectedXml = OldXmlFile_FullName[comboBox2.SelectedIndex];
            File.Delete(@"C:\\Techman Robot\\TMstudio\\pallet\\"+ SelectedXml);
            StatusBarShow("Selected file deleted.", Color.Green);
            comboBox2.DataSource = null;
            XmlFileNameInPalletFolder();
            comboBox2.DataSource = OldXmlFile_ForDisplay;
            comboBox2.SelectedItem = null;
        }
        //tab4.3 Check if the Layout.txt is export to PC correctly, delete Layout.txt in robot, import layout.txt from PC to robot, open FlowProject:MAIN
        private async void button4_Click(object sender, EventArgs e)
        {
            if (File.Exists(@"C:\\Techman Robot\\TMstudio\\TM_Export\\TMstudio\\TextFiles\\Layout.txt"))
            {
                await OperatorAPI("DeleteTextFile", "[\"Layout.txt\"]");
                await OperatorAPI("ImportTextFileFromExternalDevice", "[\"" + ShareFolder + "\",\"TMstudio\",\"Layout.txt\"]");
                if (apifeedback.ErrorCode == null)
                {
                    //await OperatorAPI("OpenProject", "[\"TMOperator_TMROBOT_TMPLTZOP_V002_Main\"]");
                    await OperatorAPI("OpenProject", "[\"" + FlowProjectName + "\"]");
                    if (apifeedback.ErrorCode == null)
                    {
                        StatusBarShow("Latest layout.txt is imported, Flow project opened", Color.Green);
                        tabControl1.SelectTab(4);
                    }
                    else
                    {
                        StatusBarShow("Flow Project open failed, please check!", Color.Red);
                    }
                }
                else
                {
                    StatusBarShow("layout.txt import failed, please check!", Color.Red);
                }


            }
            else
            {
                StatusBarShow("Can not find Layout.txt on PC, TMstudio export is not done properly.", Color.Red);
            }
        }
        //===============================================
        //tab5
        //tab5.1 API:ShowVisionJob: Landmark
        private async void button9_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowVisionJob", "[\"Step2_Box1_Recognition_Box_Position\",\"false\"]" );
        }
        //tab5.2 API: GetCoordinatesByCurrentBase, ChangePointTeachValue(teach pick point)
        private async void button11_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeCurrentBase", "vision_Step2_Box1_Recognition_Box_Position");
            await Task.Delay(300);
            await OperatorAPI("GetCoordinatesByCurrentBase", "" );
            await Task.Delay(300);
            CurrentCoordinate = apifeedback.responseData.Trim(new Char[] { '[', ']' });
            await OperatorAPI("ChangePointTeachValue", "[\"Step3_Box1_Teach_Gripping_Point\", \"" + CurrentCoordinate + "\" ]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("Cannot overwrite pick point, please check again!", Color.Red);
            }
            else
            {
                StatusBarShow("Pick point overwrite success.", Color.Green);
            }
        }
        //tab5.3.1 API:ShowVisionJob: SetVariable
        private async void button8_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeGlobalVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Use_Vision_or_Not_Operator_API\",\"false\"]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("ChangeGlobalVariableValue: Use_Vision_or_Not fail!", Color.Red);
            }
            else
            {
                StatusBarShow("Robot set to pick on fixed point without vision.", Color.Green);
            }
        }
        //tab5.3.2 API:ShowVisionJob: feature
        private async void button24_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeGlobalVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Use_Vision_or_Not_Operator_API\",\"true\"]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("ChangeGlobalVariableValue: Use_Vision_or_Not fail!", Color.Red);
            }
            else
            {
                StatusBarShow("Robot will pick based on vision feature detection.", Color.Green);
            }
            await OperatorAPI("ShowVisionJob", "[\"Step4_Box1_Visual_Recognition_SmartPick\",\"false\"]");
        }
        //tab5.4 Go to Gripper and Pillar page
        private void button53_Click(object sender, EventArgs e)
        {
            TabNumberBeforeJump = 4;
            tabControl1.SelectTab(6);
        }
        //tab5.5 Go to Advance setting page
        private void button59_Click(object sender, EventArgs e)
        {
            TabNumberBeforeJump = 4;
            tabControl1.SelectTab(7);
        }
        //tab5.6 check if box are the same in pallet0 and pallet1; if yes go to tab8, if not go to tab 6
        private void button12_Click(object sender, EventArgs e)
        {
            string[] messages = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                        .Where(line => line.StartsWith("Pallet_0_box_info="))
                        .Select(line => line.Split(new char[] { '=' }, 2)[1])
                        .ToArray();
            string Pallet_0_box_info= string.Concat(messages);
            string[] Pallet_0_box_info_array = Pallet_0_box_info.Split(',');

            string[] messages2 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
            .Where(line => line.StartsWith("Pallet_1_box_info="))
            .Select(line => line.Split(new char[] { '=' }, 2)[1])
            .ToArray();
            string Pallet_1_box_info = string.Concat(messages2);
            string[] Pallet_1_box_info_array = Pallet_1_box_info.Split(',');

            if(Pallet_0_box_info == Pallet_1_box_info)
            {
                StatusBarShow("All setup complete, Flow project ready to play.", Color.Orange);
                tabControl1.SelectTab(8);
            }
            else
            {
                StatusBarShow("Box for two pallet is different, edit next pallet.", Color.Orange);
                tabControl1.SelectTab(5);
            }
        }
        //===============================================
        //tab6
        //tab6.1 API:ShowVisionJob: Landmark
        private async void button28_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowVisionJob", "[\"Step2_Box2_Recognition_Box_Position\",\"false\"]");
        }
        //tab6.2 API: GetCoordinatesByCurrentBase, ChangePointTeachValue(teach pick point)
        private async void button29_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeCurrentBase", "vision_Step2_Box2_Recognition_Box_Position");
            await Task.Delay(300);
            await OperatorAPI("GetCoordinatesByCurrentBase", "");
            await Task.Delay(300);
            CurrentCoordinate = apifeedback.responseData.Trim(new Char[] { '[', ']' });
            await OperatorAPI("ChangePointTeachValue", "[\"Step3_Box2_Teach_Gripping_Point\", \"" + CurrentCoordinate + "\" ]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("Cannot overwrite pick point, please check again!", Color.Red);
            }
            else
            {
                StatusBarShow("Pick point overwrite success.", Color.Green);
            }
        }
        //tab6.3.1 API:ShowVisionJob: SetVariable
        private async void button20_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeGlobalVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Use_Vision_or_Not_Operator_API\",\"false\"]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("ChangeGlobalVariableValue fail!", Color.Red);
            }
            else
            {
                StatusBarShow("Robot set to pick on fixed point without vision.", Color.Green);
            }
        }
        //tab6.3.2 API:ShowVisionJob: feature
        private async void button22_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ChangeGlobalVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Use_Vision_or_Not_Operator_API\",\"true\"]");
            if (apifeedback.ErrorCode != null)
            {
                StatusBarShow("ChangeGlobalVariableValue fail!", Color.Red);
            }
            else
            {
                StatusBarShow("Robot will pick based on vision feature detection.", Color.Green);
            }
            await OperatorAPI("ShowVisionJob", "[\"Step4_Box2_Visual_Recognition_SmartPick\",\"false\"]");
        }
        //tab6.4 Go to Gripper and Pillar page
        private void button52_Click(object sender, EventArgs e)
        {
            TabNumberBeforeJump = 5;
            tabControl1.SelectTab(6);
        }
        //tab6.5 Go to Advance setting page
        private void button58_Click(object sender, EventArgs e)
        {
            TabNumberBeforeJump = 5;
            tabControl1.SelectTab(7);
        }
        //tab6.6 go to next page
        private void button39_Click(object sender, EventArgs e)
        {
            StatusBarShow("All setup complete, Flow project ready to play.", Color.Orange);
            tabControl1.SelectTab(8);
        }
        //===============================================
        //tab7
        //tab7.1 gripper on
        private async void button40_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"2\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"4\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"3\",\"0\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"5\",\"0\"]");
        }
        //tab7.2 gripper off
        private async void button41_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"2\",\"0\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"4\",\"0\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"3\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"5\",\"1\"]");
        }
        //tab7.3 pillar reset
        private async void button51_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"6\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"6\",\"0\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"9\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"9\",\"0\"]");
        }
        //tab7.4 pillar DOWN
        private async void button42_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"0\",\"0\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"1\",\"1\"]");
        }
        //tab7.5 pillar UP
        private async void button43_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"0\",\"1\"]");
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"1\",\"1\"]");
        }
        //tab7.6 pillar Stop
        private async void button50_Click(object sender, EventArgs e)
        {
            await OperatorAPI("WriteDigitalOutput", "[\"16\",\"0\",\"1\",\"0\"]");
        }
        //tab7.7 Go back to tab previously
        private void button54_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab(TabNumberBeforeJump);
        }
        //===============================================
        //tab8
        //tab8.1 show subflow: Advance2_Grip
        private async void button26_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance2_Grip\"]");
            await OperatorAPI("ShowFlow", "[\"Advance2_Grip\",\"\"]");
            await OperatorAPI("HideMainflow", ""); 
        }
        //tab8.2 show subflow: Advance3_Release
        private async void button32_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance3_Release\"]");
            await OperatorAPI("ShowFlow", "[\"Advance3_Release\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.3 show subflow: Advance4_Waitfor_Input
        private async void button33_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance4_Waitfor_Input\"]");
            await OperatorAPI("ShowFlow", "[\"Advance4_Waitfor_Input\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.4 show subflow: Advance5_Interval_Between_Layers
        private async void button34_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance5_Interval_Between_Layers\"]");
            await OperatorAPI("ShowFlow", "[\"Advance5_Interval_Between_Layers\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.5 show subflow: Advance6_Via_Point
        private async void button35_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance6_Via_Point\"]");
            await OperatorAPI("ShowFlow", "[\"Advance6_Via_Point\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.6 show subflow: Advance7_Box_Placement
        private async void button36_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance7_Box_Placement\"]");
            await OperatorAPI("ShowFlow", "[\"Advance7_Box_Placement\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.7 show subflow: Advance8_Further_Vision
        private async void button37_Click(object sender, EventArgs e)
        {
            await OperatorAPI("ShowFlow", "");
            await HideAllSubflowAndThread();
            await OperatorAPI("ShowSubflows", "[\"Advance8_Further_Vision\"]");
            await OperatorAPI("ShowFlow", "[\"Advance8_Further_Vision\",\"\"]");
            await OperatorAPI("HideMainflow", "");
        }
        //tab8.8 go to next page
        private void button55_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab(TabNumberBeforeJump);
        }
        //===============================================
        //tab9
        //tab9.1 tab control selected, data display
        private void tabControl1_Selected(Object sender, TabControlEventArgs e)
        {
            if (e.TabPage == tabPage9)
            {
                //project name and application from CurrentExecutingXmlFile
                string ProjectShortName =CurrentExecutingXmlFile.Remove(0, 22);
                textBox3.Text = ProjectShortName.Remove(ProjectShortName.Length - 4).Substring(2);
                textBox19.Text = ApplicationSelection[Convert.ToInt32(ProjectShortName.Substring(0, 1))];

                //box size acquire from Layout.txt
                string[] messages = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                        .Where(line => line.StartsWith("Pallet_0_box_info="))
                        .Select(line => line.Split(new char[] { '=' }, 2)[1])
                        .ToArray();
                string Pallet_0_box_info = string.Concat(messages);
                string[] Pallet_0_box_info_array = Pallet_0_box_info.Split(',');

                string[] messages2 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                .Where(line => line.StartsWith("Pallet_1_box_info="))
                .Select(line => line.Split(new char[] { '=' }, 2)[1])
                .ToArray();
                string Pallet_1_box_info = string.Concat(messages2);
                string[] Pallet_1_box_info_array = Pallet_1_box_info.Split(',');
                textBox21.Text = Pallet_0_box_info_array[0]+"x"+ Pallet_0_box_info_array[1] + "x" + Pallet_0_box_info_array[2];
                textBox23.Text = Pallet_1_box_info_array[0] + "x" + Pallet_1_box_info_array[1] + "x" + Pallet_1_box_info_array[2];

                //pallet size acquire from Layout.txt
                string[] messages3 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                        .Where(line => line.StartsWith("Pallet_0_info="))
                        .Select(line => line.Split(new char[] { '=' }, 2)[1])
                        .ToArray();
                string Pallet_0_info = string.Concat(messages3);
                string[] Pallet_0_info_array = Pallet_0_info.Split(',');

                string[] messages4 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                .Where(line => line.StartsWith("Pallet_1_info="))
                .Select(line => line.Split(new char[] { '=' }, 2)[1])
                .ToArray();
                string Pallet_1_info = string.Concat(messages4);
                string[] Pallet_1_info_array = Pallet_1_info.Split(',');
                textBox20.Text = Pallet_0_info_array[0] + "x" + Pallet_0_info_array[1] + "x" + Pallet_0_info_array[2];
                textBox22.Text = Pallet_1_info_array[0] + "x" + Pallet_1_info_array[1] + "x" + Pallet_1_info_array[2];


            }
            //tab10 fixed data from layout.txt
            if (e.TabPage == tabPage10)
            {
                string[] messages5 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                        .Where(line => line.StartsWith("Pallet_0_layer_wp_num="))
                        .Select(line => line.Split(new char[] { '=' }, 2)[1])
                        .ToArray();
                string Pallet_0_box_sum = string.Concat(messages5);
                string[] Pallet_0_box_sum_array = Pallet_0_box_sum.Split(',');
                textBox15.Text = Pallet_0_box_sum_array[0];

                string[] messages6 = File.ReadLines(@"C:\Techman Robot\TMstudio\TM_Export\TMstudio\TextFiles\Layout.txt")
                        .Where(line => line.StartsWith("Pallet_1_layer_wp_num="))
                        .Select(line => line.Split(new char[] { '=' }, 2)[1])
                        .ToArray();
                string Pallet_1_box_sum = string.Concat(messages6);
                string[] Pallet_1_box_sum_array = Pallet_1_box_sum.Split(',');
                textBox13.Text = Pallet_1_box_sum_array[0];
            }
        }
        //tab9.2 Play
        private async void button38_Click(object sender, EventArgs e)
        {
            //to notify Flow project now is executing by operator, so some variable will be set by operator API
            await OperatorAPI("ChangeGlobalVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Operator_API\",\"true\"]");
            
            //modbusclient.ReconnectTimeSpan = TimeSpan.FromSeconds(1);
            //await modbusclient.Connect();
            //if(modbusclient.IsConnected != true)
            //{
            //    StatusBarShow("Modbus is not connected, please try again!", Color.Red);
            //}
            //else
            //{
                var ControlOrNot = await modbusclient.ReadDiscreteInputs(1, 7205, 1);
                if (ControlOrNot[0].BoolValue == true)
                {
                    StatusBarShow(RobotIP + " Modbus connected and got Robot control", Color.Green);
                    var Playpausecoil = new Coil
                    {
                        Address = 7104,
                        BoolValue = true
                    };
                    await modbusclient.WriteSingleCoil(1, Playpausecoil);
                    tabControl1.SelectTab(9);
                    timer1.Enabled = true;
                }
                else
                {
                    StatusBarShow(" Modbus connected, but not get Robot control!", Color.Red);
                }
            //}
        }
        //===============================================
        //tab10
        //tab10 pasue/play robot
        private async void button56_Click(object sender, EventArgs e)
        {
            var Playpausecoil = new Coil
            {
                Address = 7104,
                BoolValue = true
            };
            await modbusclient.WriteSingleCoil(1, Playpausecoil);
            timer1.Enabled = true;
        }

        //tab10 stop robot
        private async void button45_Click(object sender, EventArgs e)
        {
            var Stopcoil = new Coil
            {
                Address = 7105,
                BoolValue = true
            };
            await modbusclient.WriteSingleCoil(1, Stopcoil);
            textBox18.Text = "Stop";
            textBox18.BackColor = Color.Red;
            timer1.Enabled = false;
        }
        //tab10 speed+
        private async void button46_Click(object sender, EventArgs e)
        {
            var SpeedUpcoil = new Coil
            {
                Address = 7106,
                BoolValue = true
            };
            await modbusclient.WriteSingleCoil(1, SpeedUpcoil);
        }
        //tab10 speed-
        private async void button47_Click(object sender, EventArgs e)
        {
            var SpeedDowncoil = new Coil
            {
                Address = 7107,
                BoolValue = true
            };
            await modbusclient.WriteSingleCoil(1, SpeedDowncoil);
        }
        //tab10 Data refresh timer
        private async void timer1_Tick(object sender, EventArgs e)
        {
            //Show Palletizing progress
            await OperatorAPI("GetVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_start_R_index\"]");
            textBox14.Text = (Convert.ToInt32(apifeedback.responseData)-1).ToString();
            await OperatorAPI("GetVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_start_L_index\"]");
            textBox11.Text = (Convert.ToInt32(apifeedback.responseData) - 1).ToString();
            await OperatorAPI("GetVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Right_full\"]");
            label10.Visible=Convert.ToBoolean(apifeedback.responseData);
            await OperatorAPI("GetVariableValue", "[\"g_TMOperator_TMROBOT_TMPLTZOP_Left_full\"]");
            label9.Visible = Convert.ToBoolean(apifeedback.responseData);
            //Show Speed
            var ProjectSpeed = await modbusclient.ReadInputRegisters(1, 7101, 1);
            textBox12.Text = ProjectSpeed[0].RegisterValue.ToString();
            //Show Running/Pause/Stop
            var ProjectRunningOrNot = await modbusclient.ReadDiscreteInputs(1, 7202, 1);
            var ProjectPauseOrNot = await modbusclient.ReadDiscreteInputs(1, 7204, 1);

            if (ProjectRunningOrNot[0].RegisterValue == 1)
            {
                if (ProjectPauseOrNot[0].RegisterValue == 1)
                {
                    textBox18.Text = "Pause";
                    textBox18.BackColor = Color.Yellow;
                }
                else
                {  
                    textBox18.Text = "Running";
                    textBox18.BackColor = Color.Green;
                }   
            }
            else
            {
                    textBox18.Text = "Stop";
                    textBox18.BackColor = Color.Red;
            }
        }

        //===============================================
        //extra feature: engineer mode to show or hide tabs
        private void button57_Click(object sender, EventArgs e)
        {
            var small = new Size(0, 1);
            if (tabControl1.ItemSize == small)
            {
                tabControl1.ItemSize = new Size(78, 24);
                statusStrip2.Visible = true;
            }
            else
            {
                tabControl1.ItemSize = new Size(0, 1);
                statusStrip2.Visible = false;
            }
        }
        //Close TMflow while winform closing
        private async void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            await OperatorAPI("LeaveTMflow", "true");
        }
        //top right corner X mark for winform close
        private void button60_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
